/* Tabela PRECOSECIA: PRECOSECIA */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela PRECOSECIA */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela PRECOSECIA,
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_COC_PRECOSECIA
AFTER DELETE OR INSERT OR UPDATE
ON PRECOSECIA FOR EACH ROW
DECLARE
  V_USUARIO    VARCHAR2(40);
  V_TIPO       VARCHAR2(1);
  V_ITPESQ     VARCHAR2(40);
  V_DESC       VARCHAR2(1000);
  V_DSIP       VARCHAR2(50);
  V_DSUSUARIO  VARCHAR2(50);
  V_DSRDM      VARCHAR2(50);
  V_DSMETODO   VARCHAR2(250);
  V_DSOPERADOR VARCHAR2(12);
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   WEBTUNNING(V_DSIP,
              V_DSUSUARIO,
              V_DSRDM,
              V_DSMETODO,
              V_DSOPERADOR);
   IF DELETING THEN      
      IF :OLD.CDFILIAL IS NOT NULL THEN
         V_DESC := V_DESC || 'CdFilial=' || :OLD.CDFILIAL;
      END IF;
      
      IF :OLD.CDCIA IS NOT NULL THEN
         V_DESC := V_DESC || ' Cia=' || :OLD.CDCIA;
      END IF;
      
      IF :OLD.NRTABPRECO IS NOT NULL THEN
         V_DESC := V_DESC || ' NrTabPreco=' || :OLD.NRTABPRECO;
      END IF;

      IF :OLD.CDSERVICO IS NOT NULL THEN
         V_DESC := V_DESC || ' CdServico=' || :OLD.CDSERVICO;
      END IF;

      IF :OLD.NRSEQPRECO IS NOT NULL THEN
         V_DESC := V_DESC || ' NrSeqPreco=' || :OLD.NRSEQPRECO;
      END IF;

      IF :OLD.VRPRESERV IS NOT NULL THEN
         V_DESC := V_DESC || ' VrPreServ=' || :OLD.VRPRESERV;
      END IF;

      IF :OLD.VRPRESERVD IS NOT NULL THEN
         V_DESC := V_DESC || ' VrPreSerVd=' || :OLD.VRPRESERVD;
      END IF;

      IF :OLD.VRCUSTOSE IS NOT NULL THEN
         V_DESC := V_DESC || ' VrCustoSe=' || :OLD.VRCUSTOSE;
      END IF;

      IF :OLD.VRCUSTOSEE IS NOT NULL THEN
         V_DESC := V_DESC || ' VrCustoSe=' || :OLD.VRCUSTOSEE;
      END IF;

      IF :OLD.DTHRINCPRESE IS NOT NULL THEN
         V_DESC := V_DESC || ' DtHrIncPreSe=' || :OLD.DTHRINCPRESE;
      END IF;

      IF :OLD.CDOPERPRESE IS NOT NULL THEN
         V_DESC := V_DESC || ' CdOperPreSe=' || :OLD.CDOPERPRESE;
      END IF;

      IF :OLD.DTINIVIGSE IS NOT NULL THEN
         V_DESC := V_DESC || ' DtIniVigSe=' || :OLD.DTINIVIGSE;
      END IF;

      IF :OLD.DTFIMVIGSE IS NOT NULL THEN
         V_DESC := V_DESC || ' DtFimVigSe=' || :OLD.DTFIMVIGSE;
      END IF;

      IF :OLD.NRFORMPRECIA IS NOT NULL THEN
         V_DESC := V_DESC || ' NrFormPreCia=' || :OLD.NRFORMPRECIA;
      END IF;

      IF :OLD.DTULTATUPCIA IS NOT NULL THEN
         V_DESC := V_DESC || ' DtUltAtupCia=' || :OLD.DTULTATUPCIA;
      END IF;

      V_TIPO := '3';
      V_ITPESQ := SUBSTR(:OLD.CDCIA || '|' || :OLD.NRTABPRECO || '|' || :OLD.CDSERVICO || '|' || :OLD.NRSEQPRECO, 1, 40);
   ELSE
      IF UPDATING THEN
         IF (:OLD.CDFILIAL     <> :NEW.CDFILIAL    ) OR
            (:OLD.CDCIA        <> :NEW.CDCIA       ) OR
            (:OLD.NRTABPRECO   <> :NEW.NRTABPRECO  ) OR
            (:OLD.CDSERVICO    <> :NEW.CDSERVICO   ) OR
            (:OLD.NRSEQPRECO   <> :NEW.NRSEQPRECO  ) OR
            (NVL(:OLD.VRPRESERV,0)  <> NVL(:NEW.VRPRESERV,0))  OR
            (NVL(:OLD.VRPRESERVD,0) <> NVL(:NEW.VRPRESERVD,0)) OR
            (NVL(:OLD.VRCUSTOSE,0)  <> NVL(:NEW.VRCUSTOSE,0))  OR
            (NVL(:OLD.VRCUSTOSEE,0) <> NVL(:NEW.VRCUSTOSEE,0)) OR
            (:OLD.DTHRINCPRESE <> :NEW.DTHRINCPRESE) OR
            (:OLD.CDOPERPRESE  <> :NEW.CDOPERPRESE ) OR
            (NVL(:OLD.DTINIVIGSE, SYSDATE) <> NVL(:NEW.DTINIVIGSE, SYSDATE)) OR
            (NVL(:OLD.DTFIMVIGSE, SYSDATE) <> NVL(:NEW.DTFIMVIGSE, SYSDATE)) OR
            (NVL(:OLD.NRFORMPRECIA, 0) <> NVL(:NEW.NRFORMPRECIA, 0)) OR
            (NVL(:OLD.DTULTATUPCIA, SYSDATE) <> NVL(:NEW.DTULTATUPCIA, SYSDATE)) THEN

            IF NVL(:OLD.CDFILIAL, ' ') <> NVL(:NEW.CDFILIAL, ' ') THEN
               V_DESC := V_DESC || 'CdFilial=' || :OLD.CDFILIAL || '|' || :NEW.CDFILIAL;
            END IF;

            IF NVL(:OLD.CDCIA, ' ') <> NVL(:NEW.CDCIA, ' ') THEN
               V_DESC := V_DESC || ' Cia=' || :OLD.CDCIA || '|' || :NEW.CDCIA;
            END IF;

            IF NVL(:OLD.NRTABPRECO, ' ') <> NVL(:NEW.NRTABPRECO, ' ') THEN
               V_DESC := V_DESC || ' NrTabPreco=' || :OLD.NRTABPRECO || '|' || :NEW.NRTABPRECO;
            END IF;

            IF NVL(:OLD.CDSERVICO, ' ') <> NVL(:NEW.CDSERVICO, ' ') THEN
               V_DESC := V_DESC || ' CdServico=' || :OLD.CDSERVICO || '|' || :NEW.CDSERVICO;
            END IF;

            IF NVL(:OLD.NRSEQPRECO, ' ') <> NVL(:NEW.NRSEQPRECO, ' ') THEN
               V_DESC := V_DESC || ' NrSeqPreco=' || :OLD.NRSEQPRECO || '|' || :NEW.NRSEQPRECO;
            END IF;

            IF NVL(:OLD.VRPRESERV, 0) <> NVL(:NEW.VRPRESERV, 0) THEN
               V_DESC := V_DESC || ' VrPreServ=' || :OLD.VRPRESERV || '|' || :NEW.VRPRESERV;
            END IF;

            IF NVL(:OLD.VRPRESERVD, 0) <> NVL(:NEW.VRPRESERVD, 0) THEN
               V_DESC := V_DESC || ' VrPreSerVd=' || :OLD.VRPRESERVD || '|' || :NEW.VRPRESERVD;
            END IF;

            IF NVL(:OLD.VRCUSTOSE, 0) <> NVL(:NEW.VRCUSTOSE, 0) THEN
               V_DESC := V_DESC || ' VrCustoSe=' || :OLD.VRCUSTOSE || '|' || :NEW.VRCUSTOSE;
            END IF;

            IF NVL(:OLD.VRCUSTOSEE, 0) <> NVL(:NEW.VRCUSTOSEE, 0) THEN
               V_DESC := V_DESC || ' VrCustoSe=' || :OLD.VRCUSTOSEE || '|' || :NEW.VRCUSTOSEE;
            END IF;

            IF NVL(:OLD.DTHRINCPRESE, SYSDATE) <> NVL(:NEW.DTHRINCPRESE, SYSDATE) THEN
               V_DESC := V_DESC || ' DtHrIncPreSe=' || :OLD.DTHRINCPRESE || '|' || :NEW.DTHRINCPRESE;
            END IF;

            IF NVL(:OLD.CDOPERPRESE, ' ') <> NVL(:NEW.CDOPERPRESE, ' ') THEN
               V_DESC := V_DESC || ' CdOperPreSe=' || :OLD.CDOPERPRESE || '|' || :NEW.CDOPERPRESE;
            END IF;

            IF NVL(:OLD.DTINIVIGSE, SYSDATE) <> NVL(:NEW.DTINIVIGSE, SYSDATE) THEN
               V_DESC := V_DESC || ' DtIniVigSe=' || :OLD.DTINIVIGSE || '|' || :NEW.DTINIVIGSE;
            END IF;

            IF NVL(:OLD.DTFIMVIGSE, SYSDATE) <> NVL(:NEW.DTFIMVIGSE, SYSDATE) THEN
               V_DESC := V_DESC || ' DtFimVigSe=' || :OLD.DTFIMVIGSE || '|' || :NEW.DTFIMVIGSE;
            END IF;

            IF NVL(:OLD.NRFORMPRECIA, ' ') <> NVL(:NEW.NRFORMPRECIA, ' ') THEN
               V_DESC := V_DESC || ' NrFormPreCia=' || :OLD.NRFORMPRECIA || '|' || :NEW.NRFORMPRECIA;
            END IF;

            IF NVL(:OLD.DTULTATUPCIA, SYSDATE) <> NVL(:NEW.DTULTATUPCIA, SYSDATE) THEN
               V_DESC := V_DESC || ' DtUltAtupCia=' || :OLD.DTULTATUPCIA || '|' || :NEW.DTULTATUPCIA;
            END IF;


            V_TIPO   := '2';
            V_ITPESQ := SUBSTR(:OLD.CDCIA || '|' || :OLD.NRTABPRECO || '|' || :OLD.CDSERVICO || '|' || :OLD.NRSEQPRECO, 1, 40);
         END IF;
      ELSE
         V_DESC := V_DESC || 'CdFilial=' || :NEW.CDFILIAL;
         V_DESC := V_DESC || ' Cia=' || :NEW.CDCIA;
         V_DESC := V_DESC || ' NrTabPreco=' || :NEW.NRTABPRECO;
         V_DESC := V_DESC || ' CdServico=' || :NEW.CDSERVICO;
         V_DESC := V_DESC || ' NrSeqPreco=' || :NEW.NRSEQPRECO;
         V_DESC := V_DESC || ' VrPreServ=' || :NEW.VRPRESERV;
         V_DESC := V_DESC || ' VrPreSerVd=' || :NEW.VRPRESERVD;
         V_DESC := V_DESC || ' VrCustoSe=' || :NEW.VRCUSTOSE;
         V_DESC := V_DESC || ' VrCustoSee=' || :NEW.VRCUSTOSEE;
         V_DESC := V_DESC || ' DtHrIncPreSe=' || :NEW.DTHRINCPRESE;
         V_DESC := V_DESC || ' CdOperPreSe=' || :NEW.CDOPERPRESE;
         V_DESC := V_DESC || ' DtIniVigSe=' || :NEW.DTINIVIGSE;
         V_DESC := V_DESC || ' DtFimVigSe=' || :NEW.DTFIMVIGSE;
         V_DESC := V_DESC || ' NrFormPreCia=' || :NEW.NRFORMPRECIA;
         V_DESC := V_DESC || ' DtUltAtupCia=' || :NEW.DTULTATUPCIA;

         V_TIPO   := '1';
         V_ITPESQ := SUBSTR(:NEW.CDCIA || '|' || :NEW.NRTABPRECO || '|' || :NEW.CDSERVICO || '|' || :NEW.NRSEQPRECO, 1, 40);
      END IF;
   END IF;
   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER, IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
            VALUES
               ('PRECOSECIA', SYSDATE, V_USUARIO, V_TIPO, V_ITPESQ, SUBSTR(V_DESC, 1, 300),
                V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_DSOPERADOR, NVL(:NEW.CDFILIAL, :OLD.CDFILIAL));
         END IF;
      END IF;
   END IF;
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('LOG_COC_PRECOSECIA','5.85.xxx'); END;
/
